<script lang="ts">
    import { afterUpdate, onDestroy } from 'svelte'

    import { debug } from '../../common/debug'
    import { range } from '../../../lib/collections'
    import { toggleFocus } from '../focus'
    import { moveNode, simulation } from './simulation'
    import { svgCoordinate, svgdraggable } from './drag'

    import GraphConfig from '../controls/GraphConfig.svelte'
    import Link from './Link.svelte'
    import Node from './Node.svelte'
    import NodeText from './NodeText.svelte'
    import { zoomStore } from '../zoom'
    import type { BoundingBox } from '../zoom'
    import { data } from '../data'

    let group: SVGGElement
    let svg: SVGSVGElement

    let padding = 4
    let figureWidth = 1000
    $: {
        transform.setClientWidth(figureWidth - 2 * padding)
    }

    let hasFocus = false

    const transform = zoomStore()

    let bbox: BoundingBox

    afterUpdate(() => {
        bbox = group.getBBox({ fill: true, stroke: true })
        transform.setBoundingBox(bbox)
    })

    const unsubscribe = data.subscribe(() => {
        transform.zoomFit()
    })

    onDestroy(unsubscribe)

    /**
     * If the graph has focus, mouse wheel will zoom in/out and prevent page scroll
     */
    function graphWheel(e: WheelEvent) {
        if (!hasFocus) {
            return
        }

        e.preventDefault()
        const origin = svgCoordinate(e, svg)
        const factor = 1 - e.deltaY / 100
        transform.zoom(factor, origin)
    }

</script>

<figure bind:clientWidth={figureWidth} tabindex="0" on:focus={() => { hasFocus = true }} on:blur={() => { hasFocus = false }}
        class="focus:outline-black border-2 border-donkerblauw-1 text-2xl" style="padding: {padding}px"
>
    <svg viewBox="0 0 {figureWidth - 2 * padding} {figureWidth - 2 * padding}" bind:this={svg} on:wheel={graphWheel}>
        <!-- Background rectangle to detect dragging the graph to pan -->
        <rect x="0" y="0" width={figureWidth - 2 * padding} height={figureWidth - 2 * padding} fill="white"
              use:svgdraggable
              on:svgdragstart={transform.panStart} on:svgdragmove={transform.panMove} on:svgdragend={transform.panEnd}
        />

        <g transform={$transform}>
            {#if $debug}
                <rect {...bbox} class="stroke-red-500 fill-white pointer-events-none"/>

                {#each range(-1000, 1100, 100) as line}
                    <line x1={line} y1={-1000} x2={line} y2={1000} class="stroke-grijs-4"
                          class:stroke-3={line === 0}/>
                    <line x1={-1000} y1={line} x2={1000} y2={line} class="stroke-grijs-4"
                          class:stroke-3={line === 0}/>
                {/each}
            {/if}

            <g bind:this={group}>
                {#each $simulation.links as link}
                    <Link {link}/>
                {/each}

                {#each $simulation.nodes as node}
                    <Node {node}
                          on:svgdragmove={(e) => moveNode(node, $transform.inverse().transformPoint(e.detail)) }
                          on:dblclick={() => toggleFocus({label: node.index})}
                    />
                {/each}

                {#each $simulation.nodes as node}
                    <NodeText {node} scale={1 / $transform.a} on:dblclick={() => toggleFocus({label: node.index})}/>
                {/each}
            </g>
        </g>
    </svg>
</figure>

{#if $debug}
    <GraphConfig/>
{/if}

<style>
</style>